/*
Copyright Renaud GICQUEL 2006  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.corps.*;
import java.util.*; 
import javax.swing.*;

/**
 * classe de combustion de biomasse
 * 
 * @author Renaud GICQUEL
 */
public class BiomassCombustion extends ExtMixer
{
    protected static java.util.ResourceBundle resIntTh_fr = java.util.ResourceBundle.getBundle("IntTh",Locale.getDefault());  
    
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField NH3_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField lambda_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField Tfig_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField k_CO_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField C_solid_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField H2O_comb_value = new javax.swing.JTextField();
    
    double Tamont, Taval, Pamont, Paval,P, Xinlet, Tcombur, Hcombur, synGasFlow,fuelFlow,fuelM,comburFlow,comburM,massWaterFlow;
    String synGasProcess,fuelProcess,comburProcess,comburSubstanceName,fuelSubstanceName,synGasSubstanceName;
    String synGasPoint,fuelPoint,comburPoint,waterProcess,waterPoint;
    rg.corps.Corps comburSubstance,NewComburSubstance,fuelSubstance,synGasSubstance,NewFuelSubstance;
    
    Vector synGasComp, comburComp;
	                
    double fractH2O,Htot,synGasM, Hcarb,Tcarb,T_syngas,lambda,Twater,Hwater,Pwater;
    
    public BiomassCombustion (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel1.setText("lambda");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,120,164,20);
		JPanel1.add(lambda_value);
		lambda_value.setBounds(164,120,100,20);
		lambda_value.setText("3");
		lambda_value.setEditable(false);
		JLabel2.setText("NH3 (% dry mass)");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,0,164,20);
		JPanel1.add(NH3_value);
		NH3_value.setBounds(164,0,100,20);
		NH3_value.setText("0.317");
		JLabel3.setText("quench T (C)");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,164,20);
		JPanel1.add(Tfig_value);
		Tfig_value.setBounds(164,48,100,20);
		Tfig_value.setText("0.05");
		JLabel4.setText("CO2 diss. rate");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,164,20);
		JPanel1.add(k_CO_value);
		k_CO_value.setBounds(164,72,100,20);
		k_CO_value.setText("0");
	//	k_CO_value.setEditable(false);
		JLabel5.setText("C solid (% dry mass)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,24,164,20);
		JPanel1.add(C_solid_value);
		C_solid_value.setBounds(164,24,100,20);
		C_solid_value.setText("5.25");
		JLabel6.setText("H2O in combustion (%)");
		JPanel1.add(JLabel6);
		JLabel6.setBounds(0,96,164,20);
		JPanel1.add(H2O_comb_value);
		H2O_comb_value.setBounds(164,96,100,20);
		H2O_comb_value.setText("100");
		type=getType();
		thermoCouplerTypes=new String[0];//no thermocoupler
    }
    public void init(){
	    getMixerStructure();
        checkConsistency();
    }
    
    public String getType(){
        return "biomass combustion";
    }
	public String getClassDescription(){
	    return "biomass combustion model\none thermocoupler\n\nauthor : R. Gicquel  april 2006\n\nRef : ModeleBiomasseCombustion.doc";
	}
    
	public void calculateProcess(){
	
	    getMixerStructure();
        checkConsistency();
	    
	    if(isBuilt){//si le noeud externe est bien configur
	        
	        //initialisation des dbits molaires de NH3 et de carbone
	        double NH3Flow=fuelFlow*Util.lit_d(NH3_value.getText())/100;//mass flow
	        double CFlow=fuelFlow*Util.lit_d(C_solid_value.getText())/100;//mass flow
	        double additionalFlow=NH3Flow+CFlow;//pour correction dbit comburant
	        NH3Flow=NH3Flow/17.034;//molar flow   DeltaH=1,5*241820-46190=316 540
	        CFlow=CFlow/12;//molar flow DeltaH=393 520
	        
	        //analyse de la composition du comburant
	        Vector comburComp=comburSubstance.getGasComposition();
            double fractO2=Util.molarComp(comburComp,"O2");//fraction molaire de O2
            double comburMolFlow=comburFlow/comburM;
            double O2MolFlow=comburMolFlow*fractO2-0.75*NH3Flow-CFlow;//dbit d'oxygne restant dans le comburant
            if(O2MolFlow<0){
	            String msg = "Not enough oxygen in oxidizer for NH3 and C";
	            JOptionPane.showMessageDialog(me, msg);  
            }
            double fractN2=Util.molarComp(comburComp,"N2");//fraction molaire de N2
            double fractAr=Util.molarComp(comburComp,"Ar");//fraction molaire de Ar
	        double totalCombFlow=O2MolFlow+(fractN2+fractAr)*comburMolFlow
	        +NH3Flow*(0.5// 1/2 N2
	                  +1.5// 3/2 H2O
	                  )+CFlow;// CO2
	         
	        fractN2=(fractN2*comburMolFlow+0.5*NH3Flow)/totalCombFlow;
	        fractAr=fractAr*comburMolFlow/totalCombFlow;
	        double fractH2O=(1.5*NH3Flow)/totalCombFlow;
	        double fractCO2=CFlow/totalCombFlow;
	        fractO2=O2MolFlow/totalCombFlow;
	        
	        //dtermination de la composition du comburant modifi
	        Vector vComp=new Vector();
            Double[]fracMol= new Double[5],molarMass= new Double[5];
            String[] nom_gaz_comp = new String[5];
            vComp.addElement(new Integer(5));
	        nom_gaz_comp[0]="N2";
	        nom_gaz_comp[1]="O2";
	        nom_gaz_comp[2]="Ar";
	        nom_gaz_comp[3]="H2O";
	        nom_gaz_comp[4]="CO2";
	        fracMol[0]=new Double(fractN2);
	        fracMol[1]=new Double(fractO2);
	        fracMol[2]=new Double(fractAr);
	        fracMol[3]=new Double(fractH2O);
	        fracMol[4]=new Double(fractCO2);
	        molarMass[0]=new Double(28.02);
	        molarMass[1]=new Double(32);
	        molarMass[2]=new Double(39.95);
	        molarMass[3]=new Double(18.02);
	        molarMass[4]=new Double(44.01);
            vComp.addElement(nom_gaz_comp);
            vComp.addElement(fracMol);
            vComp.addElement(fracMol);
            vComp.addElement(molarMass);
            
	        NewComburSubstance=Util.createIdealGas("comburant");//cration d'un nouveau gaz compos
	        NewComburSubstance.updateGasComposition(vComp);//modification de la composition du comburant
	        
	        double waterFlow=massWaterFlow*Util.lit_d(H2O_comb_value.getText())/100.;//partie de l'eau prise en compte dans la combustion
	        
            double fractH2OFuel=1./(1.+fuelFlow/fuelM*18.01528/waterFlow);//fraction molaire de H2O

	        Vector fuelComp=fuelSubstance.getGasComposition();
            double inlet_w=18.01528*fractH2OFuel/fuelM/(1-fractH2OFuel);//(M_H2O)(x_H2O)/(M_gs)/(x_gs)
            	        
	        //modification de la composition du combustible
	        NewFuelSubstance=Util.createIdealGas("wetFuel");//cration d'un nouveau gaz compos
	        
	        //dans un premier temps on charge la composition du gaz sec
            NewFuelSubstance.updateGasComposition(fuelComp);
            
            //puis on impose l'humidit
	        vComp=new Vector();
            vComp.addElement(new Integer(-1));
            vComp.addElement("setGasHum");
	        vComp.addElement(Util.aff_d(inlet_w));
            NewFuelSubstance.updateGasComposition(vComp);
            
	        Vector vSubst=NewFuelSubstance.getSubstProperties();
            Double z=(Double)vSubst.elementAt(7);
            fuelM=z.doubleValue();//masse molaire du combustible humide

	        //la charge est gale  la chaleur libre par la combustion de NH3 et C, moins la chaleur de vaporisation de l'eau
//	        double Q=46190*NH3Flow+393520*CFlow-2444*massWaterFlow;//charge totale (kJ)
	        double Q=393520*NH3Flow+393520*CFlow;//charge totale (kJ)
	        System.out.println("Q : "+Q);
	        Q=Q-2444*massWaterFlow;//charge totale (kJ)
	        double heatLoad=Q*fuelM/(fuelFlow+waterFlow);//ramen  1 kmol de combustible	  
	        
	        
	        //Initialisation de la combustion
	        Vector vSettings=new Vector();
	        vSettings.addElement(NewComburSubstance);
	        vSettings.addElement(NewFuelSubstance);
	        vSettings.addElement(new Double(comburFlow+additionalFlow));//oxidizer flow rate
	        vSettings.addElement(new Double(fuelFlow+waterFlow));//fuel flow rate
	        vSettings.addElement(new Double(3.));//lambda (inutilis ici)
	        vSettings.addElement(new Double(1000.));//Tcomb (inutilis ici)
	        vSettings.addElement(new Double(Util.lit_d(k_CO_value.getText())));//dissociation rate
	        vSettings.addElement("true");//dissociation boolean
	        vSettings.addElement(new Double(Util.lit_d(Tfig_value.getText())+273.15));//Tfigeage
	        vSettings.addElement(new Double(0.));//a (inutilis ici)
	        vSettings.addElement(new Double(0.));//hf0carb (inutilis ici)
	        vSettings.addElement("false");//comb CHa
	        vSettings.addElement(new Double(Hcarb));//hc
	        vSettings.addElement(new Double(Hcarb));//uc
	        vSettings.addElement("true");//setFuelFlow
	        vSettings.addElement(new Double(heatLoad));//heat load
	        vSettings.addElement("true");//open system
	        vSettings.addElement("true");//IcalcDirect //si true on calcule Tad  partir de lambda
	        vSettings.addElement(synGasSubstance);
	        vSettings.addElement(new Double(Tcombur));//T amont
	        vSettings.addElement(new Double(Hcombur));//H amont
	        vSettings.addElement(new Double(1.));//rendement chambre
	        
	        calcExternalCombustion(vSettings);//lancement des calculs de combustion
	        
	        Vector results=getExternalCombustionResults();//Vector des rsultats
	        
            Double y=(Double)results.elementAt(2);
            double lambda=y.doubleValue();
	        System.out.println("lambda : "+lambda);
	        lambda_value.setText(Util.aff_d(lambda,5));
	        
	        synGasSubstance=(Corps)results.elementAt(0);
            y=(Double)results.elementAt(1);
            T_syngas=y.doubleValue();
            y=(Double)results.elementAt(5);
            k_CO_value.setText(Util.aff_d(y.doubleValue(),4));
            
            y=(Double)results.elementAt(6);
            double DeltaH=y.doubleValue();
	        System.out.println("DeltaH : "+DeltaH);
            
            y=(Double)results.elementAt(4);
            double eta_comb=y.doubleValue();
	        System.out.println("eta_comb : "+eta_comb);
            
	        synGasSubstance.CalcPropCorps(T_syngas,Pamont, 1); //recalcul de l'tat de sortie (fournit Hsubst)
            getSubstProperties(synGasSubstanceName);
	        double Houtlet=Hsubst;
	        
	        
	        //mise  jour de la composition du gaz pour tenir compte de l'eau non prise en compte dans la combustion
	        double waterExcessFlow=massWaterFlow*(1.-Util.lit_d(H2O_comb_value.getText())/100.);//partie de l'eau non prise en compte dans la combustion
            
	        synGasFlow=comburFlow+fuelFlow+additionalFlow+waterFlow;
            double fractExcessH2O=1./(1.+synGasFlow/Msubst*18.01528/waterExcessFlow);//fraction molaire de H2O
            
	        fuelComp=synGasSubstance.getGasComposition();
            Integer taille=(Integer)fuelComp.elementAt(0);
            int nbComp=taille.intValue();
            
	        vComp=new Vector();
            vComp.addElement(new Integer(nbComp));
            fracMol= new Double[nbComp];molarMass= new Double[nbComp];
            nom_gaz_comp = new String[nbComp];
           
            for(int i=0;i<nbComp;i++){
                String[]noms=(String[])(fuelComp.elementAt(1));
	            nom_gaz_comp[i]=noms[i];
	            if(!nom_gaz_comp[i].equals("H2O")){
	                Double[]frac=(Double[])(fuelComp.elementAt(2));
                    double x=frac[i].doubleValue();
	                fracMol[i]=new Double(x*(1-fractExcessH2O));
	                Double[]M=(Double[])(fuelComp.elementAt(4));
	                molarMass[i]=M[i];
	            }
	            else{
	                Double[]frac=(Double[])(fuelComp.elementAt(2));
                    double x=frac[i].doubleValue();
	                fracMol[i]=new Double(x*(1-fractExcessH2O)+fractExcessH2O);
	                Double[]M=(Double[])(fuelComp.elementAt(4));
	                molarMass[i]=M[i];
	            }
            }
            vComp.addElement(nom_gaz_comp);
            vComp.addElement(fracMol);
            vComp.addElement(fracMol);
            vComp.addElement(molarMass);
	      	        
	        synGasSubstance.updateGasComposition(vComp);//modification de la composition du gaz en sortie

	        //recherche de la temprature de sortie (on suppose que l'enthalpie de l'eau est gale  celle du carburant)
	        double Hout=Houtlet*synGasFlow+Hcarb*waterExcessFlow;
	        DeltaH=Hout-Hcarb*(massWaterFlow+fuelFlow)-Hcombur*comburFlow;
            synGasFlow=synGasFlow+waterExcessFlow;
	        Hout=Hout/synGasFlow;
	        double Tout=synGasSubstance.getT_from_hP(Hout,Pamont);
	        
	        //mise  jour du noeud en utilisant les mthodes gnriques
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
	        setupVector(fuelProcess, fuelPoint, 0, fuelFlow, Tcombur, Pamont, 1);
	        setupVector(comburProcess, comburPoint, 1, comburFlow, Tcombur, Pamont, 1);
	        setupVector(waterProcess, waterPoint, 2, massWaterFlow, Tcombur, Pamont, 1);
	        setupVector(synGasProcess, synGasPoint, 3, synGasFlow, Tout, Pamont, 1);
            updateMixer(vTransfo,vPoints,Tout,Hout);

	        me.updateProcess(setEnergyTypes(synGasProcess,0,DeltaH,0));//DeltaH nergie payante
        }
	}

    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[3];
        isBuilt=true;
        fuelProcess="";
        comburProcess="";
        if(nBranches!=3){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 3";
	        JOptionPane.showMessageDialog(me, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String aval=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(aval);//direct parsing of point property vector
                getSubstProperties(nomCorps);
                String nom=nomCorps;
	            if(nom.equals(resIntTh_fr.getString("eau"))){//le corps d'entre est de l'eau
	                waterProcess=nomBranche[j];
	                waterPoint=aval;	  
	                
                    args=new String[2];
                    args[0]="process";//type of the element (see method getProperties(String[] args))
                    args[1]=waterProcess;//name of the process (see method getProperties(String[] args))
                    Vector vProp=proj.getProperties(args);
                    aval=(String)vProp.elementAt(1);//gets the downtream point name
                    getPointProperties(aval);//direct parsing of point property vector
	                Twater=Tpoint;
	                Hwater=Hpoint;
                    Pwater=Ppoint;
	                Double f=(Double)vProp.elementAt(3);
	                massWaterFlow=f.doubleValue();
	            }
	            else if(typeSubst==4){//le corps d'entre est un gaz compos
                    Vector vComp=lecorps.getGasComposition();
                    System.out.println(" nbElements "+vComp.elementAt(0));

	                if(Util.contains(vComp,"O2")&& Util.contains(vComp,"N2")){
	                    comburProcess=nomBranche[j];
	                    comburPoint=aval;
                        args=new String[2];
                        args[0]="process";//type of the element (see method getProperties(String[] args))
                        args[1]=comburProcess;//name of the process (see method getProperties(String[] args))
                        Vector vProp=proj.getProperties(args);
                        aval=(String)vProp.elementAt(1);//gets the upstream point name
                        getPointProperties(aval);//direct parsing of point property vector
	                    Tcombur=Tpoint;
	                    Hcombur=Hpoint;
                        Pamont=Ppoint;
	                    comburSubstance=lecorps;
	                    comburSubstanceName=nomCorps;
	                    Double f=(Double)vProp.elementAt(3);
	                    comburFlow=f.doubleValue();
	                    comburM=Msubst;
	                }
	                else{
	                    fuelProcess=nomBranche[j];
	                    fuelPoint=aval;
                        args=new String[2];
                        args[0]="process";//type of the element (see method getProperties(String[] args))
                        args[1]=fuelProcess;//name of the process (see method getProperties(String[] args))
                        Vector vProp=proj.getProperties(args);
                        aval=(String)vProp.elementAt(1);//gets the upstream point name
                        getPointProperties(aval);//direct parsing of point property vector
	                    Tcarb=Tpoint;
	                    Hcarb=Hpoint;
 	                    fuelSubstance=lecorps;
	                    fuelSubstanceName=nomCorps;
	                    Double f=(Double)vProp.elementAt(3);
	                    fuelFlow=f.doubleValue();
	                    fuelM=Msubst;
	                }
	            
	            
	            }
	            else{//le corps de sortie n'est ni de l'eau ni un gaz compos
	                String msg = "Error: the outlet substance is not of the right type";
	                JOptionPane.showMessageDialog(me, msg);  
	            }
	        }
	        if((fuelProcess.equals(""))||(comburProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(me, msg);  
	            isBuilt=false;
	        }
        }
        synGasProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=synGasProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    Double f=(Double)vPropMain.elementAt(3);
	    synGasFlow=f.doubleValue();
	    String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    getPointProperties(aval);//direct parsing of point property vector
        Vector vComp=lecorps.getGasComposition();
        synGasSubstance=lecorps;
	    synGasPoint=aval;
        synGasSubstanceName=nomCorps;
	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        synGasComp=lecorps.getGasComposition();//composition du gaz  traiter
        fractH2O=Util.molarComp(synGasComp,"H2O");//fraction molaire de H2O
        synGasM=Msubst;//masse molaire du gaz  traiter
        Htot=Hsubst*synGasFlow;
    }

	public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "NH3_value");
        double x=0;
        if(valeur!=null)x=Util.lit_d(valeur);
	    NH3_value.setText(Util.aff_d(x,3));
		x=Util.lit_d(Util.extr_value(ligne_data, "C_solid_value"));
	    C_solid_value.setText(Util.aff_d(x,2));
		x=Util.lit_d(Util.extr_value(ligne_data, "Tfig_value"));
	    Tfig_value.setText(Util.aff_d(x,2));
		x=Util.lit_d(Util.extr_value(ligne_data, "k_CO_value"));
	    k_CO_value.setText(Util.aff_d(x,4));
	    valeur=Util.extr_value(ligne_data, "lambda_value");
        if(valeur!=null)lambda=Util.lit_d(valeur);
	    lambda_value.setText(Util.aff_d(lambda,4));
	    valeur=Util.extr_value(ligne_data, "H2O_comb_value");
	    x=100;
        if(valeur!=null)x=Util.lit_d(valeur);
	    H2O_comb_value.setText(Util.aff_d(x,1));
	}
	
    public String saveCompParameters(){
	    String h=""
	    +"lambda_value="+lambda_value.getText()+tab
	    +"NH3_value="+NH3_value.getText()+tab
	    +"C_solid_value="+C_solid_value.getText()+tab
	    +"Tfig_value="+Tfig_value.getText()+tab
	    +"k_CO_value="+k_CO_value.getText()+tab
	    +"H2O_comb_value="+H2O_comb_value.getText()+tab
	    
	    ;
        return h;
    }
}